﻿
Structure ColExt
  Col_name.s
  Col_ID.l
  Col_type.i
  Col_Grbit.l
  Col_cbMax.l
  Codepage.l

  List Row_Text.s()
EndStructure

Structure DataTable
  TableName.s
  List DataColumn.ColExt()
EndStructure : Global NewList dt.DataTable() : Global.s NewList Tables()

Procedure AddTable2Database(Tablename.s, NewTable.b = 0)
  If NewTable : AddElement(dt()) : EndIf

  dt()\TableName = Tablename

  If NewTable
    AddElement(Tables()) : Tables() = Tablename
  EndIf
EndProcedure


Procedure AddColumn2Database(col_Name.s, col_ID.l = 0, Col_type.l = 0, Col_Grbit.l = 0, Col_cbMax.l = 0)
  AddElement(dt()\DataColumn())

  If col_Name
    dt()\DataColumn()\Col_name = col_Name
  EndIf
  If col_ID
    dt()\DataColumn()\Col_ID = col_ID
  EndIf
  If Col_type
    dt()\DataColumn()\Col_type = Col_type
  EndIf
  If Col_Grbit
    dt()\DataColumn()\Col_Grbit = Col_Grbit
  EndIf
  If Col_cbMax
    dt()\DataColumn()\Col_cbMax = Col_cbMax
  EndIf
EndProcedure

Procedure AddRow2DataTable(Row_Text.s, Row_Text2.s = "", Row_Text3.s = "", Row_Text4.s = "",  Row_Text5.s = "")

  If Row_Text
    AddElement(dt()\DataColumn()\Row_Text())
    dt()\DataColumn()\Row_Text() = Row_Text
  EndIf
  If Row_Text2
    AddElement(dt()\DataColumn()\Row_Text())
    dt()\DataColumn()\Row_Text() = Row_Text2
  EndIf
  If Row_Text3
    AddElement(dt()\DataColumn()\Row_Text())
    dt()\DataColumn()\Row_Text() = Row_Text3
  EndIf
  If Row_Text4
    AddElement(dt()\DataColumn()\Row_Text())
    dt()\DataColumn()\Row_Text() = Row_Text4
  EndIf
  If Row_Text5
    AddElement(dt()\DataColumn()\Row_Text())
    dt()\DataColumn()\Row_Text() = Row_Text5
  EndIf
EndProcedure

Procedure RetrieveTables()
  Protected.l TypeOffSet, NameOffSet, dtRowOffSet

  ClearList(Tables())

  If ListIndex(dt()) = -1 : ProcedureReturn 0 : EndIf

  ForEach dt()\DataColumn()
    If dt()\DataColumn()\Col_name = "Type" : TypeOffSet = ListIndex(dt()\DataColumn())
    ElseIf dt()\DataColumn()\Col_name = "Name" : NameOffSet = ListIndex(dt()\DataColumn())
    EndIf
  Next

  SelectElement(dt()\DataColumn(), TypeOffSet)
  ForEach dt()\DataColumn()\Row_Text()
    If dt()\DataColumn()\Row_Text() = "1"
      dtRowOffSet = ListIndex(dt()\DataColumn()\Row_Text())
      *Old_Element = @dt()\DataColumn()

      SelectElement(dt()\DataColumn(), NameOffSet)
      SelectElement(dt()\DataColumn()\Row_Text(), dtRowOffSet)

      AddElement(Tables())
      Tables() = dt()\DataColumn()\Row_Text()

      ChangeCurrentElement(dt()\DataColumn(), *Old_Element)
    EndIf
  Next
EndProcedure


Procedure PopulateListView(TableID.l)
  Global.s JET_TableName
  Protected k

  If ListIndex(dt()) = -1 : StatusBarText(0, 0, "") : ProcedureReturn 0 : EndIf

  ForEach dt()\DataColumn()
    AddGadgetColumn(2, ListIndex(dt()\DataColumn()), dt()\DataColumn()\Col_name, 120)     

    ForEach dt()\DataColumn()\Row_Text()
      If dt()\DataColumn()\Col_Grbit & #JET_bitColumnNotNULL = #JET_bitColumnNotNULL And
         dt()\DataColumn()\Row_Text() = "" : dt()\DataColumn()\Row_Text() = "0" : EndIf        
        
      If ListIndex(dt()\DataColumn()) > 0
        SetGadgetItemText(2, k, dt()\DataColumn()\Row_Text(), ListIndex(dt()\DataColumn()))
      Else
        AddGadgetItem(2, -1, dt()\DataColumn()\Row_Text()) : k=-1
      EndIf : k+1
    Next : k=0
  Next
  
  ForEach dt()\DataColumn()
    If dt()\DataColumn()\Col_Grbit = 524290
      SendMessage_(GadgetID(2), #LVM_SETCOLUMNWIDTH, ListIndex(dt()\DataColumn()), #LVSCW_AUTOSIZE)
    EndIf
  Next  

  StatusBarText(0, 0, "Database=" + JET_DbFilePart + " | Table=" + GetGadgetText(1) + " | Rows=" + CountGadgetItems(2) + " | View=Contents")
EndProcedure


CompilerIf #PB_Compiler_IsMainFile
  Procedure SizeWindowHandler()
    ResizeGadget(2, #PB_Ignore, #PB_Ignore, WindowWidth(EventWindow())-20, WindowHeight(EventWindow())-StatusBarHeight(0)-60)
  EndProcedure

  Procedure Int_Main(Tables.b = 0)
    Global.s tbDatabase
    Protected tmpVal.l

    If OpenWindow(0, 0, 0, 370, 340, "DataTables Viewer", #PB_Window_SystemMenu | #PB_Window_ScreenCentered| #PB_Window_MinimizeGadget | #PB_Window_MaximizeGadget)

      If CreateStatusBar(0, WindowID(0))
        AddStatusBarField(#PB_Ignore)
      EndIf

      FrameGadget(0, 10, 5, 280, 43, "Tables")

      ComboBoxGadget(1, 18, 20, 250, 21)

      ListIconGadget(2, 10, 50, WindowWidth(0)-20, WindowHeight(0)-StatusBarHeight(0)-60, "", 120, #PB_ListIcon_GridLines)



      ForEach Tables()
        AddGadgetItem(1, -1, Tables())
      Next

      If Tables : tmpVal = Tables-1 : Else : tmpVal = 0 : EndIf : SetGadgetState(1, tmpVal)

      PostEvent(#PB_Event_Gadget, 0, 1)

      BindEvent(#PB_Event_SizeWindow, @SizeWindowHandler())

      Repeat
        Event = WaitWindowEvent()

        If Event = #PB_Event_Gadget
          Select EventGadget()
            Case 1
              ClearGadgetItems(2)

              For k=0 To ListSize(dt()\DataColumn())
                RemoveGadgetColumn(2, 0)
              Next : k=0

              If Tables = 1
                SelectElement(dt(), GetGadgetState(1))
                PopulateListView(GetGadgetState(1))
              EndIf


          EndSelect
        EndIf

      Until Event = #PB_Event_CloseWindow
    EndIf
  EndProcedure


  AddTable2Database("Alpha Roger", 1)

  AddColumn2Database("Column_1", 111, 0, 2)
  AddRow2DataTable("1st Row, 1st Column", "2nd Row, 1st Column", "3rd Row, 1st Column (Extra Width)", "4th Row, 1st Column", "5th Row, 1st Column")

  AddColumn2Database("Column_2", 222)
  AddRow2DataTable("1st Row, 2nd Column", "2nd Row, 2nd Column", "3rd Row, 2nd Column", "4th Row, 2nd Column", "5th Row, 2nd Column")

  AddColumn2Database("Column_3", 333)
  AddRow2DataTable("1st Row, 3rd Column", "2nd Row, 3rd Column", "3rd Row, 3rd Column", "4th Row, 3rd Column", "5th Row, 3rd Column")

  AddColumn2Database("Column_4", 444, 0, 2)
  AddRow2DataTable("1st Row, 4th Column (Extra Width)", "2nd Row, 4th Column", "3rd Row, 4th Column", "4th Row, 4th Column", "5th Row, 4th Column")

  AddColumn2Database("Column_5", 555)
  AddRow2DataTable("1st Row, 5th Column", "2nd Row, 5th Column", "3rd Row, 5th Column", "4th Row, 5th Column", "5th Row, 5th Column")

  AddColumn2Database("Column_6", 666)
  AddRow2DataTable("1st Row, 6th Column", "2nd Row, 6th Column", "3rd Row, 6th Column", "4th Row, 6th Column", "5th Row, 6th Column")


  AddTable2Database("Contacts", 1)

  AddColumn2Database("Names", 1112)
  AddRow2DataTable("1st Row, 1st Column", "2nd Row, 1st Column", "3rd Row, 1st Column")

  AddColumn2Database("Addresses", 1113)
  AddRow2DataTable("1st Row, 2nd Column", "2nd Row, 2nd Column", "3rd Row, 2nd Column")

  AddColumn2Database("Phone Numbers", 1114)

  Int_Main(1)
CompilerEndIf
; IDE Options = PureBasic 5.44 LTS (Windows - x64)
; CursorPosition = 121
; FirstLine = 109
; Folding = --
; EnableUnicode
; EnableXP
; EnablePurifier